﻿BrokerItemlist = LibStub("AceAddon-3.0"):NewAddon("Broker_Itemlist", "AceBucket-3.0", "AceEvent-3.0")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local QTC = LibStub('LibQTip-1.0')
local C = LibStub("AceConfigDialog-3.0")

local mod = BrokerItemlist

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "enUS", true)
	
if L then
	L["Add item"] = true
	L["Add new item to track.  Drag the item to this input box."] = true
	L["Currency shown in text"] = true
	L["Currency you wish to monitor in tooltip."] = true
	L["Currency you wish to show in text field."] = true
	L["Currency"] = true
	L["Custom Icon settings"] = true
	L["Delete item"] = true
	L["Dev Mode"] = true
	L["Horizontal distance between icon and text."] = true
	L["Icon size"] = true
	L["Icon x offset"] = true
	L["Icon y offset"] = true
	L["Items you wish to monitor in tooltip."] = true
	L["Items you wish to show in text field."] = true
	L["Items"] = true
	L["List of current items.  Click to delete item."] = true
	L["Makes icon size setting effect inline text and allows x/y offset adjustment."] = true
	L["Options"] = true
	L["Settings"] = true
	L["Show in text"] = true
	L["Text Icon size"] = true
	L["Vertical attachment of text to icon."] = true
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "zhTW")
	
if L then
L["Add item"] = "新增物品"
L["Add new item to track.  Drag the item to this input box."] = "新增物品追蹤。拖動此物品本匯入框。"
L["Currency"] = "通貨"
L["Currency shown in text"] = "通貨顯示在文字"
L["Currency you wish to monitor in tooltip."] = "要在工具提示監視的通貨。"
L["Currency you wish to show in text field."] = "你想在文字顯示的通貨"
L["Custom Icon settings"] = "自訂圖示設定"
L["Delete item"] = "刪除物品"
L["Dev Mode"] = [=[開發模式
]=]
L["Horizontal distance between icon and text."] = "圖標和文字之間的水平距離。"
L["Icon size"] = "圖示大小"
L["Icon x offset"] = "圖示 x 偏移距"
L["Icon y offset"] = "圖示 y 偏移距"
L["Items"] = "物品"
L["Items you wish to monitor."] = "你希望觀看的物品"
L["Items you wish to monitor in tooltip."] = "你想在工具提示監視的物品"
L["Items you wish to show in text field."] = "你想顯示在文本字段中的物品"
L["List of current items.  Click to delete item."] = "目前清單物品。點選刪除物品"
L["Makes icon size setting effect inline text and allows x/y offset adjustment."] = "圖標大小設置的效果內嵌文字，並允許 X / Y偏移調整。"
L["Options"] = "選項"
L["Settings"] = "設定"
L["Show in text"] = "顯示文字"
L["Text Icon size"] = "文字圖示尺寸"
L["Vertical attachment of text to icon."] = "垂直對齊文字到圖標。"

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "ruRU")
	
if L then
L["Add item"] = "Добавить предмет"
L["Add new item to track.  Drag the item to this input box."] = "Добавить новый предмет для отслеживания. Перетащите предмет в поле ввода"
L["Delete item"] = "Удалить предмет"
L["Icon size"] = "Размер иконок"
L["Items"] = "Предметы"
L["List of current items.  Click to delete item."] = "Список предметов на данный момент. Кликните для удаления предмета"
L["Settings"] = "Настройки"
L["Show in text"] = "Отображать в качестве текста"

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "koKR")
	
if L then
L["Add item"] = "아이템 추가"
L["Add new item to track.  Drag the item to this input box."] = "표시할 새로운 아이템을 추가합니다. 해당 아이템을 입력칸에 드래그하세요."
L["Delete item"] = "아이템 삭제"
L["Dev Mode"] = "개발 보드"
L["Icon size"] = "아이콘 크기"
L["Items"] = "아이템"
L["Items you wish to monitor."] = "모니터 할 아이템"
L["Items you wish to show in text field."] = "텍스트 필드에 표시할 아이템"
L["List of current items.  Click to delete item."] = "현재 아이템 목록. 삭제할 아이템을 클릭하세요."
L["Settings"] = "설정"
L["Show in text"] = "텍스트 표시"

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "frFR")
	
if L then
L["Add item"] = "Ajouter un objet"
L["Add new item to track.  Drag the item to this input box."] = "Ajouter un nouvel objet a suivre. Deplacer l'objet dans cette boite de dialogue."
L["Delete item"] = "Effacer l'objet"
L["Dev Mode"] = "Mode developpeur"
L["Icon size"] = "Taille de l'icône"
L["Items"] = "Objets"
L["Items you wish to monitor."] = "Objets que vous voulez suivre"
L["Items you wish to show in text field."] = "Objets que vous voulez voir dans le champ texte"
L["List of current items.  Click to delete item."] = "Liste des objets courrant. Cliquer pour effacer un objet"
L["Settings"] = "Paramétrage"
L["Show in text"] = "Montrer au format texte"

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "deDE")
	
if L then
L["Add item"] = "Gegenstand hinzufügen"
L["Currency"] = "Währung"
L["Custom Icon settings"] = "Benutzerdefinierte Symbol-Einstellungen"
L["Delete item"] = "Gegenstand löschen"
L["Horizontal distance between icon and text."] = "Horizontaler Abstand zwischen Symbol und Text."
L["Icon size"] = "Symbolgröße"
L["Items"] = "Gegenstände"
L["Items you wish to monitor."] = "Gegenstände die du beobachten möchtest."
L["Options"] = "Optionen"
L["Settings"] = "Einstellungen"

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "zhCN")
	
if L then
L["Add item"] = "新增物品"
L["Add new item to track.  Drag the item to this input box."] = "新增物品追踪。将物品拖拽入本输入框。"
L["Currency"] = "货币（工具提示）"
L["Currency shown in text"] = "货币（LDB文本）"
L["Currency you wish to monitor in tooltip."] = "在工具提示上显示的货币。"
L["Currency you wish to show in text field."] = "在LDB文本上显示的货币。"
L["Custom Icon settings"] = "自定义图标设置"
L["Delete item"] = "删除物品"
L["Dev Mode"] = "调试模式"
L["Horizontal distance between icon and text."] = "图标与文本之间的水平距离。"
L["Icon size"] = "图标大小"
L["Icon x offset"] = "图标x轴偏移"
L["Icon y offset"] = "图标y轴偏移"
L["Items"] = "物品（工具提示）"
L["Items you wish to monitor."] = "你想要监视的物品。"
L["Items you wish to monitor in tooltip."] = "在工具提示上显示的物品。"
L["Items you wish to show in text field."] = "在LDB文本上显示的物品。"
L["List of current items.  Click to delete item."] = "当前物品清单。点击以删除物品。"
L["Makes icon size setting effect inline text and allows x/y offset adjustment."] = "调整图标与文本的大小及对齐。"
L["Options"] = "选项"
L["Settings"] = "设置"
L["Show in text"] = "物品（LDB文本）"
L["Text Icon size"] = "文本图标大小"
L["Vertical attachment of text to icon."] = "图标与文本之间的垂直距离。"

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "esMX")
	
if L then

end

local L = LibStub("AceLocale-3.0"):GetLocale("Broker_Itemlist")

local db
local PLAYER_LEVEL = UnitLevel("player")
local BAGUPDATING
local SCANNING
local playerClass
local ItemInfo = {}
local sorted = {}
local itemsList
local currencyList
local CURRENCYUPDATED
local tinsert = table.insert
local tremove = table.remove

local ClassIcons = { ["DRUID"] = "Interface\\Icons\\INV_Misc_Branch_01", ["MAGE"] = "Interface\\Icons\\INV_Misc_Dust_01", ["PALADIN"] = "Interface\\Icons\\INV_Stone_WeightStone_05",
			["PRIEST"] = "Interface\\Icons\\INV_Misc_Candle_03", ["ROGUE"] = "Interface\\Icons\\Trade_BrewPoison", ["SHAMAN"] = "Interface\\Icons\\INV_Jewelry_Talisman_06",
			["WARLOCK"] = "Interface\\Icons\\INV_Misc_Gem_Amethyst_02", ["DEATHKNIGHT"] = "Interface\\Icons\\INV_Misc_Dust_02", ["HUNTER"] = "Interface\\Icons\\INV_Ammo_Arrow_02",
			["WARRIOR"] = "Interface\\Icons\\INV_Shield_46", ["MONK"] = "Interface\\Icons\\INV_Staff_07"
}

local ReagentDefaults = { 	["DRUID"] = {17021, 17026, 22148, 17034, 44605},
				["MAGE"] = {17020, 17031, 17032}, ["PALADIN"] = {}, ["PRIEST"] = {17028, 17029},
				["ROGUE"] = {7676, 6947, 2892, 3775, 5237, 10918, 21835}, ["SHAMAN"] = {17030},
				["WARLOCK"] = {}, ["DEATHKNIGHT"] = {},	["HUNTER"] = {}, ["WARRIOR"] = {}, ["MONK"] = {}
}

local QualityColor = {	[1] = "|c009d9d9d", 
			[2] = "|c00ffffff", 
			[3] = "|c001eff00", 
			[4] = "|c000070dd", 
			[5] = "|c00a335ee",
			[6] = "|c00ff8000", 
			[7] = "|c00e6cc80"
}

local defaults = {
	profile = {
		currency = {},
		customicon = nil,
		devmode = nil,
		firstrun = true,
		iconsize = 24,
		iconx = 0,
		icony = 0,
		texticonsize = 20,
		tracking = {},
		sortedtext = {},
		bank = {}
	}
}

local options = {
	name = "Broker Itemlist",
	handler = mod,
	type = "group",
	args = { 
		options = {
			name = L["Options"],
			handler = mod,
			type = "group",
			args = {
				items = {
				 	type = "multiselect",
				 	name = L["Items"],
				 	desc = L["Items you wish to monitor in tooltip."],
				 	get = function(info, id) 
				 			return mod:ItemExists("tracking", id) 
				 		end,
				 	set = function(info, id) 
				 			mod:ToggleItem("tracking", id)
				 		end,
				 	values = "GetItems", 
				 	order = 5
				},
				textify = {
					type = "multiselect",
				 	name = L["Show in text"],
				 	desc = L["Items you wish to show in text field."],
				 	get = function(info, id) 
				 			return mod:ItemOnText(id) 
				 		end,
				 	set = function(info, id) 
				 			mod:ToggleTextItem(id)
				 		end,
				 	values = "GetItems", 
					order = 8
				},
				currency = {
				 	type = "multiselect",
				 	name = L["Currency"],
				 	desc = L["Currency you wish to monitor in tooltip."],
				 	get = function(info, id) 
				 			return mod:ItemExists("currency", id) 
				 		end,
				 	set = function(info, id) 
				 			mod:ToggleItem("currency", id)
				 		end,
				 	values = "GetCurrency", 
				 	order = 9
				},
				currencytext = {
					type = "multiselect",
				 	name = L["Currency shown in text"],
				 	desc = L["Currency you wish to show in text field."],
				 	get = function(info, id) 
				 			return mod:ItemOnText(id) 
				 		end,
				 	set = function(info, id) 
				 			mod:ToggleTextItem(id)
				 		end,
				 	values = "GetCurrency", 
					order = 10
				},
				head = {
					type = "header",
					name = L["Settings"],
					order = 11
				},
				additem = {
					type = "input",
					name = L["Add item"],
					desc = L["Add new item to track.  Drag the item to this input box."],
					set = 	function(info, v) mod:AddNewItem(v) end,
					order = 12
				},
				delitem = {
					type = "select",
					name = L["Delete item"],
					desc = L["List of current items.  Click to delete item."],
					set = function(info, id) mod:RemoveItem(id) end,
					values = "GetItems",
					order = 15
				},
				iconsize = {
					type = "range",
					name = L["Icon size"],
					get = function() return mod.db.profile.iconsize end,
					set = 	function(info, v) mod.db.profile.iconsize = v mod:UpdateBrokerText() end,
					min = 8, 
					max = 40, 
					step = 1,
					order = 18
				},
				customicon = {
					type = "toggle",
					name = L["Custom Icon settings"],
					desc = L["Makes icon size setting effect inline text and allows x/y offset adjustment."],
					get = function() return mod.db.profile.customicon end,
					set = function(info, v) mod.db.profile.customicon = v mod:UpdateBrokerText() end,
					order = 20
				},
				texticonsize = {
					type = "range",
					name = L["Text Icon size"],
					get = function() return mod.db.profile.texticonsize end,
					set = 	function(info, v) mod.db.profile.texticonsize = v mod:UpdateBrokerText() end,
					min = 8, 
					max = 40, 
					step = 1,
					hidden = function() return not mod.db.profile.customicon end,
					order = 22
				},
				iconx = {
					type = "range",
					name = L["Icon x offset"],
					desc = L["Horizontal distance between icon and text."],
					get = function() return mod.db.profile.iconx end,
					set = 	function(info, v) mod.db.profile.iconx = v mod:UpdateBrokerText() end,
					min = -50, 
					max = 50, 
					step = 1,
					order = 25,
					hidden = function() return not mod.db.profile.customicon end
				},
				icony = {
					type = "range",
					name = L["Icon y offset"],
					desc = L["Vertical attachment of text to icon."],
					get = function() return mod.db.profile.icony end,
					set = 	function(info, v) mod.db.profile.icony = v mod:UpdateBrokerText() end,
					min = -10, 
					max = 20, 
					step = 1,
					order = 30,
					hidden = function() return not mod.db.profile.customicon end
				},
				dev = {
					type = "toggle",
					name = L["Dev Mode"],
					get = function() return mod.db.profile.devmode end,
					set = function(info, v) mod.db.profile.devmode = v end,
					order = 50
				},
			}
		}
	}
}
		

function mod:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BrokerItemlistDB", defaults)
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Broker_Itemlist", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_Itemlist", "Broker_Itemlist")
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	
	self:OnFirstRun()
	self:CreateLDBObject()
end

function mod:OnEnable()
	db = mod.db.profile
	
	SCANNING = nil
	self.scanQ = {}
	self:InitialiseItemInfo()
	self:UpdateBrokerText()
	self.bucket = self:RegisterBucketEvent("BAG_UPDATE", 10)
	self:RegisterEvent("BANKFRAME_OPENED")	
	self:RegisterEvent("BANKFRAME_CLOSED")	
	self:RegisterEvent("CURRENCY_DISPLAY_UPDATE", "CURRENCY_UPDATE")
end

function mod:OnDisable()
	
end

function mod:OnFirstRun()
	_, playerClass = UnitClass("player")
	if mod.db.profile.firstrun and ReagentDefaults[playerClass][1] then
		for _, item in pairs(ReagentDefaults[playerClass]) do
			mod.db.profile.tracking[item] = true
			tinsert(mod.db.profile.sortedtext, item)
		end
		mod.db.profile.firstrun = false
	end
end

function mod:OnProfileChanged()
	db = self.db.profile
	self:OnFirstRun()
	ItemInfo = {}
	self:InitialiseItemInfo()
	self:UpdateCurrencies()
	self:BAG_UPDATE()
end

function mod:debug(message)
	if db.devmode then
		DEFAULT_CHAT_FRAME:AddMessage("ITEMLIST: " .. (message or "NIL"))
	end
end

function mod:UpdateCurrencies()
	local numEntries = GetCurrencyListSize()
	self:debug(numEntries)
	for i = 1, numEntries do	
		local name, isHeader, _, _, _, count, icon = GetCurrencyListInfo(i)
		if not isHeader then
			self:debug(name)
			if not db.currency[name] and db.currency[name] ~= false then
				db.currency[name] = true
			end
			ItemInfo[name] = {name = name, icon = icon, count = count, max = 1, thisweek = 1, weeklymax = 1, color = QualityColor[2], quality = 2, type = nil}
		end
	end
	self:UpdateValorCap()
	if numEntries ~= 0 then CURRENCYUPDATED = true end
end

function mod:UpdateValorCap()
	local name, _, _, earnedThisWeek, weeklyMax, totalMax = GetCurrencyInfo(396)
	if ItemInfo[name] then
		ItemInfo[name].max = totalMax
		ItemInfo[name].thisweek = earnedThisWeek
		ItemInfo[name].weeklymax = weeklyMax/100
	end
end

function mod:InitialiseItemInfo()
	for item, use in pairs(db.tracking) do
		if use or self:ItemOnText(item) then self:AddItem(item) end
	end
end

function mod:ItemExists(key, id)
	if db[key][id] then return true
	else return false end
end

function mod:ToggleItem(key, id)
	db[key][id] = not db[key][id]
	self:UpdateBrokerText()
end

function mod:ItemOnText(id)
	if self:TextShown(id) then return true 
	else return false end
end

function mod:ToggleTextItem(id)
	local index = self:TextShown(id)
	if not index then tinsert(db.sortedtext, id) 
	else tremove(db.sortedtext, index) end
	self:UpdateBrokerText()
end

function mod:TextShown(item)
	for num, id in pairs(db.sortedtext) do
		if id == item then return num end
	end
	return nil
end

function mod:GetItems()
	itemsList = {}
	for item in pairs(db.tracking) do
		self:debug(item)
		if ItemInfo[item] then
			itemsList[item] = ItemInfo[item].color .. ItemInfo[item].name .. "|r"
		end
	end
	return itemsList
end

function mod:GetCurrency()
	currencyList = {}
	for item in pairs(db.currency) do
		self:debug(item)
		if ItemInfo[item] then
			currencyList[item] = ItemInfo[item].name 
		end
	end
	return currencyList
end

function mod:AddNewItem(itemlink)
	if not itemlink then return end
	local item = self:GetItemID(itemlink)
	if item and (not db.tracking[item] or db.tracking[item] == false) then
		db.tracking[item] = true
		mod:AddItem(item)
		mod:BAG_UPDATE()
	end 
end

function mod:RemoveItem(id)
	db.tracking[id] = nil
	local index = self:TextShown(id)
	if index then tremove(db.sortedtext, index) end
	self:UpdateBrokerText()
end

function mod:CreateLDBObject()
	mod.obj = ldb:NewDataObject("Broker_Itemlist", {
		type = "data source",
		icon = ClassIcons[playerClass],
		label = "Itemlist",
		OnClick = function(frame, button)
				if button == "RightButton" then
					if not C.OpenFrames["Broker_Itemlist"] then 
						mod:UpdateCurrencies() 
						C:Open("Broker_Itemlist") 
					else C:Close("Broker_Itemlist") end
				end
			end,
		OnEnter = function(frame)
				local tooltip = QTC:Acquire("Broker_ItemlistTooltip", 3, "LEFT", "LEFT", "RIGHT")
				tooltip:Clear()
				tooltip:SmartAnchorTo(frame)
				tooltip:SetScript("OnLeave", mod.HideTooltip)
				mod.tooltip = tooltip
				mod:DisplayTooltip()
			end,
		OnLeave = function()
				mod:HideTooltip()
			end,
	})

end

function mod:HideTooltip()
	if self.tooltip then
		self.tooltip:Hide()
		QTC:Release(self.tooltip)
		self.tooltip = nil
	end
end

function mod:UpdateBrokerText()
	local icons
	local text = ""
	for _, itemid in ipairs(db.sortedtext) do
		if ItemInfo[itemid] then
			local data = ItemInfo[itemid]
			text = text .. "|T" .. data.icon 
			if db.customicon then text = text .. ":" .. db.texticonsize .. ":" .. db.texticonsize .. ":" .. db.iconx .. ":" .. db.icony .. "|t" 
			else text = text .. ":0|t" end
			local color
			if data.count < data.max then color = "|c00FFFF00"
			else color = "|c0000FF00" end 
			text = text .. color .. data.count .. "|r"
			icons = true
		end
	end
	if icons then
		mod.obj.text = text
	else 
		mod.obj.text = ""
	end
end

function mod:DisplayTooltip()
	sorted = {}
	for itemid, show in pairs(db.tracking) do
		if show and ItemInfo[itemid] then
			local data = ItemInfo[itemid]
			table.insert(sorted, {name = data.name, icon = data.icon, count = data.count, max = data.max, color = data.color, quality = data.quality})
		end
	end
	for itemname, show in pairs(db.currency) do
		if show and ItemInfo[itemname] then
			local data = ItemInfo[itemname]
			table.insert(sorted, {name = data.name, icon = data.icon, count = data.count, max = data.max, thisweek = data.thisweek, weeklymax = data.weeklymax, color = data.color, quality = data.quality})
		end
	end
	if not sorted or #sorted == 0 then return end
	table.sort(sorted, function(a,b) 
				if a.quality == b.quality then
					return a.name < b.name 
				else
					return a.quality > b.quality
				end
	end)
	for _, data in ipairs(sorted) do
		local icontext = "|T" .. data.icon .. ":" .. db.iconsize .. "|t"
		local nametext = data.color .. data.name .. "|r"
		local color = "|c0000FF00"
		local specialtext = ""
		if data.thisweek and data.weeklymax and data.thisweek < data.weeklymax then 
			specialtext = "(" .. data.thisweek .. "/" .. data.weeklymax .. ")"
			color = "|c00FFFF00"
		elseif data.count < data.max then color = "|c00FFFF00" end
		local counttext = color .. data.count .. specialtext .. "|r"
		mod.tooltip:AddLine(icontext, nametext, counttext)
	end
			
	mod.tooltip:Show()
	self:UpdateBrokerText()
end

function mod:CURRENCY_UPDATE()
	CURRENCYUPDATED = nil
	self:BAG_UPDATE()
end

function mod:BAG_UPDATE()
	self:debug("Bag_UPDATE")
	if BAGUPDATING then return end
	local BANKCLEARED
	BAGUPDATING = true
	if not CURRENCYUPDATED then self:UpdateCurrencies() end
	for item, data in pairs(ItemInfo) do
		data.count = 0 
	end
	for bag = 11, -1, -1 do
		local size = GetContainerNumSlots(bag)
		if (size > 0) then
			if bag > 4 and not BANKCLEARED then
				db.bank = {}
				BANKCLEARED = true
			end
			for slot = 1, size do
				local _, itemCount = GetContainerItemInfo(bag, slot)
				if itemCount then
					local itemName, itemLink, _, _, _, _, _, _, _, itemTexture = GetItemInfo(GetContainerItemLink(bag, slot))
					if itemLink then
						local itemId = self:GetItemID(itemLink)
						if ItemInfo[itemId] then
							if db.tracking[itemId] or self:ItemOnText(itemId) then 
								if bag > 4 or bag == -1 then
									self:UpdateBankItem(itemId, itemCount)
								else 
									ItemInfo[itemId].count = ItemInfo[itemId].count + itemCount 
								end
							else
								for trackitem in pairs(db.tracking) do
									if ItemInfo[trackitem] and ItemInfo[trackitem].name and string.find(itemName, ItemInfo[trackitem].name) then
										if bag > 4 or bag == -1 then
											self:UpdateBankItem(itemId, itemCount)
										else
											ItemInfo[trackitem].count = ItemInfo[trackitem].count + itemCount
										end
										break
									end
								end
							end
						end
					end
				end
			end
		end
	end
	for itemid, show in pairs(db.tracking) do
		if db.bank[itemid] and (show or self:ItemOnText(itemid)) and ItemInfo[itemid] then
			ItemInfo[itemid].count = ItemInfo[itemid].count + db.bank[itemid]
		end
	end
	BAGUPDATING = nil
	self:CurrencyBagUpdate()
	self:UpdateBrokerText()
end

function mod:BANKFRAME_OPENED()
	self:debug("Bank opened")
	self:UnregisterBucket(self.bucket)
	self:RegisterEvent("BAG_UPDATE")
	if not BAGUPDATING then self:BAG_UPDATE() end
end

function mod:BANKFRAME_CLOSED()
	self:debug("Bank closed")
	self:UnregisterEvent("BAG_UPDATE")
	self.bucket = self:RegisterBucketEvent("BAG_UPDATE", 10)
end

function mod:UpdateBankItem(item, num)
	if db.bank[item] then
		db.bank[item] = db.bank[item] + num
	else
		db.bank[item] = num
	end
	self:debug("Added "..num.." of "..item)
end

function mod:GetItemID(link)
	local _,_, itemId = string.find(link, "item:(%d+):")
	itemId = tonumber(itemId)
	return itemId				
end

function mod:AddItem(item)
	if not ItemInfo[item] then
		local itemName, _, itemRarity, _, _, itemType, _, itemStackCount, _, itemTexture = GetItemInfo(item)
		if not itemName then 
			self:ScanTooltip(item, true)
			return
		end
		self:debug("Adding .."..itemName)
		ItemInfo[item] = {name = itemName, icon = itemTexture, count = 0, max = itemStackCount, color = QualityColor[itemRarity + 1], quality = itemRarity, type = itemType}
	end
end

function mod:CurrencyBagUpdate()
	for i=1,GetCurrencyListSize() do
      		local name, _, _, _, _, count, _, _, itemID = GetCurrencyListInfo(i)
		if ItemInfo[name] then ItemInfo[name].count = count end
    	end
end

function mod:ScanTooltip(item)
	if not mod.Scanner then 
		mod.Scanner = CreateFrame("GameTooltip", "Itemlist_ScannerTooltip", nil, "GameTooltipTemplate")
		mod.Scanner:SetOwner(UIParent, "ANCHOR_NONE")
	end
	if not SCANNING then 
		mod:debug("Start scanning .."..item)
		SCANNING = true
		mod.Scanner.id = item
		mod.Scanner:SetScript('OnTooltipSetItem', function() return mod:OnTooltipSetItem() end)
		mod.Scanner:SetHyperlink('item:'..item)
	else 
		mod:debug("Qued .."..item)
		tinsert(mod.scanQ, item)
	end
end

function mod:OnTooltipSetItem()
	if not mod.Scanner or not mod.Scanner.id then return end
	mod:debug("Returned itemlookup")
	if GetItemInfo(mod.Scanner.id) then
		mod.Scanner:SetScript('OnTooltipSetItem', nil)
		mod:debug("Returned .. "..mod.Scanner.id)
		mod:AddItem(mod.Scanner.id)
		SCANNING = nil
		mod.Scanner.id = nil
		if #mod.scanQ > 0 then
			local scanitem = mod.scanQ[1]
			tremove(mod.scanQ, 1)
			mod:ScanTooltip(scanitem)
		end
	else 
		mod:debug("GetItemInfo failed for .. "..mod.Scanner.id)
	end
end